package org.example.wedding_app_backend.weddingBudget.entity;

import jakarta.persistence.*;
import lombok.*;
import org.example.wedding_app_backend.wedding.entity.WeddingEntity;
import java.time.LocalDateTime;
import java.util.UUID;

@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "wedding_budget")
public class WeddingBudgetEntity {

    @Id
    private UUID id;

    private String name;

    private String category;

    private Double amount;

    private LocalDateTime paymentDate;

    private LocalDateTime paymentDueDate;

    private String paymentMethod;

    private String status;

    private String payerName;

    private String serviceName;

    private String servicePhoneNumber;

    private String link;

    private String notes;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "wedding")
    private WeddingEntity wedding;
}
