package org.example.wedding_app_backend.weddingConfirmationGroup.entity;

import jakarta.persistence.*;
import lombok.*;
import org.example.wedding_app_backend.wedding.entity.WeddingEntity;
import org.example.wedding_app_backend.weddingGuest.entity.WeddingGuestEntity;

import java.util.List;
import java.util.UUID;

@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@ToString
@EqualsAndHashCode
@Entity
@Table(name = "wedding_confirmation_groups")
public class WeddingConfirmationGroupEntity {

    @Id
    private UUID id;

    private String name;

    @OneToMany(mappedBy = "weddingConfirmationGroup", cascade = CascadeType.REMOVE, fetch = FetchType.LAZY)
    @ToString.Exclude
    @EqualsAndHashCode.Exclude
    private List<WeddingGuestEntity> guestsGroup;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "wedding")
    private WeddingEntity wedding;

}
