package org.example.wedding_app_backend.weddingConfirmationGroup.function;

import org.example.wedding_app_backend.weddingConfirmationGroup.dto.GetWeddingConfirmationGroupWithGuestsInside;
import org.example.wedding_app_backend.weddingConfirmationGroup.entity.WeddingConfirmationGroupEntity;
import org.example.wedding_app_backend.weddingGuest.dto.GetWeddingGuestInformation;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

@Component
public class GetConfirmationGroupWithGuests implements Function<List<WeddingConfirmationGroupEntity>, List<GetWeddingConfirmationGroupWithGuestsInside>> {
    @Override
    public List<GetWeddingConfirmationGroupWithGuestsInside> apply(List<WeddingConfirmationGroupEntity> weddingConfirmationGroupEntitiesList) {

        return weddingConfirmationGroupEntitiesList.stream().map(group ->
                GetWeddingConfirmationGroupWithGuestsInside.builder()
                        .id(group.getId())
                        .name(group.getName())
                        .guestList(
                                group.getGuestsGroup().stream()
                                        .map(guest -> GetWeddingConfirmationGroupWithGuestsInside.WeddingGuestInformation.builder()
                                                .id(guest.getId())
                                                .presenceConfirmed(guest.getPresenceConfirmed())
                                                .guestName(guest.getGuestName())
                                                .guestAge(guest.getGuestAge())
                                                .build())
                                        .collect(Collectors.toList())
                        )
                        .build()
        ).collect(Collectors.toList());
    }
}
