package org.example.wedding_app_backend.weddingConfirmationGroup.service;

import lombok.RequiredArgsConstructor;
import org.example.wedding_app_backend.wedding.entity.WeddingEntity;
import org.example.wedding_app_backend.weddingConfirmationGroup.dto.GetWeddingConfirmationGroup;
import org.example.wedding_app_backend.weddingConfirmationGroup.entity.WeddingConfirmationGroupEntity;
import org.example.wedding_app_backend.weddingConfirmationGroup.repository.WeddingConfirmationGroupRepository;
import org.example.wedding_app_backend.weddingGuest.dto.GetWeddingGuestWithGroupInformation;
import org.example.wedding_app_backend.weddingGuest.entity.WeddingGuestEntity;
import org.example.wedding_app_backend.weddingGuest.repository.WeddingGuestRepository;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Service
@RequiredArgsConstructor
public class WeddingConfirmationGroupService {

    private final WeddingGuestRepository weddingGuestRepository;

    private final WeddingConfirmationGroupRepository weddingConfirmationGroupRepository;

    public void save(WeddingConfirmationGroupEntity group) {
        weddingConfirmationGroupRepository.save(group);
    }

    public Optional<List<WeddingGuestEntity>> findWeddingConfirmationGroupGuestsByWeddingIdAndGuestId(UUID weddingId, UUID guestId) {
        Optional<WeddingGuestEntity> weddingGuestEntity = weddingGuestRepository.findByWeddingIdAndId(weddingId, guestId);

        return weddingGuestEntity.map(guestEntity -> guestEntity.getWeddingConfirmationGroup().getGuestsGroup());

    }

    public Optional<WeddingConfirmationGroupEntity> findWeddingConfirmationGroupById(UUID groupId) {
        return weddingConfirmationGroupRepository.findById(groupId);
    }

    public Optional<List<WeddingConfirmationGroupEntity>> findAllByWeddingId(UUID weddingId) {return weddingConfirmationGroupRepository.findAllByWeddingId(weddingId);}

    public void createWeddingConfirmationGroup(GetWeddingConfirmationGroup request,WeddingEntity wedding)throws IOException {
        WeddingConfirmationGroupEntity confirmationGroup = new WeddingConfirmationGroupEntity();

        confirmationGroup.setId(UUID.randomUUID());
        confirmationGroup.setName(request.getName());
        confirmationGroup.setWedding(wedding);

        try {
            weddingConfirmationGroupRepository.save(confirmationGroup);
        } catch (Exception e) {
            throw new IllegalStateException(e);
        }
    }

    public void deleteConfirmationGroup(WeddingConfirmationGroupEntity confirmationGroup) throws IOException {
        try {
            weddingConfirmationGroupRepository.delete(confirmationGroup);
        } catch (Exception e) {
            throw new IllegalStateException(e);
        }
    }

}
